class ConsoleReporter {
	async init(options) {
		this.logger = options.logger;
		this.sessionTx = 0;
		this.currentTx = 0;
	}

	async countTransaction() {
		this.currentTx++;
	}

	async onInterval() {
		if (!this.currentTx) {
			return;
		}
		this.sessionTx += this.currentTx;
		this.logger.info(`${this.currentTx} transaction(s) counted. (${this.sessionTx} total)`);
		this.currentTx = 0;
	}
}

module.exports = ConsoleReporter;
