const utilsFactory = require('./utils');
const methodsFactory = require('./methods');

module.exports = (APIBuilder) => {
	const Connector = APIBuilder.Connector;
	const Capabilities = Connector.Capabilities;
	const logger = APIBuilder.logger;
	const utils = utilsFactory(APIBuilder, { logger });
	const methods = methodsFactory(Connector, utils);
	const Composite = Connector.extend({
		filename: module.filename,
		pkginfo: {
			name: 'composite',
			version: 'built-in',
			description: 'Compose models from many connectors'
		},
		capabilities: [
			Capabilities.CanCreate,
			Capabilities.CanRetrieve,
			Capabilities.CanUpdate,
			Capabilities.CanDelete
		],
		logger,
		...methods
	});
	const compositeInstance = new Composite();
	compositeInstance.connected = true;
	compositeInstance.enabled = true;
	return compositeInstance;
};
