const requireUncached = require('require-uncached');

/**
 * require() alternative which does an uncached require when reloading
 * also injects a .filename prop into the required component.
 */
const requireComponent = (name, reload) => {
	// now let require do it's work depending on if we are forcing a reload or not
	const retVal = reload ? requireUncached(name) : require(name);
	retVal.filename = retVal.filename || name;
	return retVal;
};

exports.requireComponent = requireComponent;
