/**
 * Calls `bind` on all the pluggable middlewares.
 * @param {APIBuilder} apibuilder  - The API Builder instance.
 * @returns <Promise>
 */
async function bindMiddlewares(apibuilder) {
	const middlewareManager = apibuilder._internal.getMiddlewareManager();
	return middlewareManager.bind();
}

module.exports = bindMiddlewares;
