const plugins = require('../plugins');

/**
 * Registers all configured dataconnector plugins.
 */
async function registerConnectors() {
	// Start configured connectors
	for (const name	of Object.keys(this.config && this.config.connectors || {})) {
		const config = this.config.connectors[name];
		if (!config.connector) {
			continue;
		}
		if (plugins.isPluginName(name)) {
			throw new Error(`Error configuring dataconnector ${name}. You cannot use the a plugin name as the alias in the configuration.`);
		}
		// This will create the connector, and register it.
		const connector = this.getConnector(name);
		if (connector && config.enabled !== false && config.modelAutogen) {
			// Register usage of modelAutogen for this connector instance
			this._internal.pluginUse.registerConnector(config.connector, name);
		}
	}
}

module.exports = registerConnectors;
