const Billing = require('../billing/billing');

async function startBilling({ runtimeVersion }) {
	const config = this.config.subscriptionUsageTracking;
	if (config && config.enabled) {
		const billingManager = new Billing();
		this._internal.setBillingManager(billingManager);
		await billingManager.init(config, {
			logger: this.logger,
			runtimeVersion,
			dir: this.config.dir
		});
	} else if (config && !config.enabled) {
		this.logger.info('Subscription usage tracking is disabled');
	}
}

module.exports = startBilling;
