/**
 * A plugin error.
 * This error is always terminal in runtime.
 */
class PluginError extends Error {
	constructor(...params) {
		super(...params);
		this.name = 'PluginError';
	}
}

/**
 * Encountered a runtime error.
 * This error is not terminal in development, but is terminal in production.
 * This error is used for non-critical validation errors.
 */
class ProductionError extends Error {
	constructor(...params) {
		super(...params);
		this.name = 'ProductionError';
	}
}

module.exports = {
	PluginError,
	ProductionError
};
